import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

public class OptiMidlet extends MIDlet implements CommandListener {

    private static final boolean debug = false;
    private Display display;
    private MyCanvas myCanvas;
    private Form form;
    private StringItem timeItem = new StringItem("as: ", "");
    private Command commandStart = new Command("Start", Command.SCREEN, 1);
    private Command commandExit = new Command("Konec", Command.EXIT, 2);

    public boolean running = true;

    public OptiMidlet() {

        display = Display.getDisplay(this);

        form = new Form("Opti Midlet");

        form.append(timeItem);

        form.addCommand(commandStart);
        form.addCommand(commandExit);
        form.setCommandListener(this);

        myCanvas = new MyCanvas(this);
    }

    public void startApp() throws MIDletStateChangeException {
        running = true;
        display.setCurrent(form);
    }

    public void pauseApp() {
        running = false;
    }

    public void exitCanvas(int status) {

        debug("exitCanvas - status = " + status);

        switch (status) {
            case MyCanvas.USER_EXIT:
                timeItem.setText("Ukoneno");
                break;

            case MyCanvas.EXIT_DONE:
                timeItem.setText(myCanvas.elapsed + "ms");
                break;
        }

        display.setCurrent(form);
    }

    public void destroyApp(boolean unconditional) throws MIDletStateChangeException {
        myCanvas = null;
        display.setCurrent(null);
        display = null;
    }

    public void commandAction(Command command, Displayable displayable) {
        if (command == commandExit) {
            myCanvas = null;
            display.setCurrent(null);
            display = null;
            notifyDestroyed();
        } else {
            running = true;
            display.setCurrent(myCanvas);
            myCanvas.start();
        }
    }

    public static final void debug(String s) {
        if (debug) System.out.println(s);
    }
}